// Javascript code to work with multiple versions of flip.html
// 2017/10/26 J.A.Wrotniak   Original Version
// 2018/05/08 jaw - cleaned gui redraw
// 2018/05/28 jaw - better help
//      05/30 bsp ok on chrome
// 2018/06/19 scrolling image list, alternate keys
// 2018/07/05 short file names
// 2018/09/13 Beter with Edge
// 2018/09/21 Jump to ##
// 2018/12/08 Help text cleanup
// 2019/06/11 Up and Down keys used
// 2020/05/23 OnClick added
// 2020/05/28 Changes to main panel, _oi added

var _ver = '1.30';

var _oi = 0;  /* ??? */
var _ini = "";
var _old = ""; // ID of old "Flip to) item
var _cur = ""; // ID of current item
var _lock = 0; // is _old locked?
var _dt = 2000;
var _idt = 1;
var _itim = 0;
var _hlp = 0;
var _ran = 0;
var _cap_on = 1;
var _timr = 0; // opening timer
var _ctim = 0;
var _done = 0;
var _flip = 0;
var _logo = _hide < 2;
var _v1 = _id.length == 0 ? 1 : 0;
var _N;
var _kbuf  = '';
var _ktim  = 0;
var _kbd_dt = 1000;

if (_hide>2) _cap_on = 0;
_oi = (typeof _i_start === 'undefined') ? 0 : _i_start;


//--------------------------------------------------------------

function getArg( arg ) {
    var url = window.location.href;
    var exp = new RegExp('[?&]'+arg+'=([^&#]*)','i');
    var s = exp.exec(url);
    var t = s ? s[1] : '';
    if (_id.indexOf(t)<0) t = '';
    return t;
    };

//--------------------------------------------------------------

function doneLogo() {
   document.getElementById('LOGO').style.display = 'none';
   document.getElementById('HINT').style.display = 'none';
   clearInterval(_itim);
   _itim = 0;
}

//--------------------------------------------------------------

function doLogo() {
   var e1 = document.getElementById('LOGO');
   var e2 = document.getElementById('HINT');
   if (_itim) {
     clearInterval(_itim);
     e1.style.display = 'none';
     e2.style.display = 'none';
   }
   if (_done==1||_logo==0) return;
   e1.style.display = "inline-block";
   e2.style.display = "inline-block";
   e1.innerHTML = 'The Flipper';
   e2.innerHTML = 'Press <span class=KEY>H</span> for Help any time';
   _done = 1;
   _itim =  setInterval(doneLogo,2400);
}

//--------------------------------------------------------------

//--------------------------------------------------------------

function selThis(who) {
   alert('sel');
   // document.getElementById(who).state = normal;
}

//--------------------------------------------------------------


function doLock() {
   // Pressing [L] will lock the current item, unless it is already
   // locked, in which case it will be unlocked.
   var c = document.getElementById(_cur);
   if (c.value=='LOCK') { // remove lock
      c.value = '';
      _lock = 0;
      _old = '';
   }
   else { // remove lock if any, set new one
      if (_old!='') document.getElementById(_old).value = '';
      c.value = 'LOCK';
      _lock = 1;
      _old = _cur;
   }
   showThis(_cur);
//   document.getElementById("LOCK").checked = _lock;
}

//--------------------------------------------------------------

function getId(i) {
   if (_v1) {
      return _oo[i][0];
   }
   return _id[i];
}

//--------------------------------------------------------------

function getLabel(i) {
   if (_v1) {
      var o = _oo[i][1];
      if(o=='') o = _oo[i][0];
      return o;
   }
   var o = _lab[i];
   if(!o||o=='') o = _id[i];
   return o;
}

//--------------------------------------------------------------

function getCaption(i) {
   if (_v1) {
      var o = _oo[i][2];
      if(o=='') o = _oo[i][1];
      if(o=='') o = shortName(i);
      return o;
   }
   var o = _lab[i];
   if(!o||o=='') o = shortName(i);
   return o;
}

//--------------------------------------------------------------

function fileName(i) {
   return _pre+getId(i)+_suf;
}

function shortName(i) {
   var s = fileName(i);
   var n = s.lastIndexOf('\/');
   s = s.substring(n+1);
   return s;
}

//--------------------------------------------------------------

function doneCaption() {
   document.getElementById('CAPT').style.display = 'none';
   clearInterval(_ctim);
   _ctim = 0;
}

//--------------------------------------------------------------

function toggleCaption() {
   if (_ctim) {
      _cap_on = 0;
      doneCaption();
      // alert('Captions OFF');
   }
   else {
      _cap_on = 1;
      doCaption();
      //    alert('Captions ON');
   }
}

//--------------------------------------------------------------

function doCaption() {
   var e = document.getElementById('CAPT');
   if (!_cap_on) {
      e.style.display = 'none';
      return;
   }
   var i = _id.indexOf(_cur);
   var s = getCaption(i);
   e.style.display = 'inline-block';
   i += _oi;
   e.innerHTML = '#'+i+' :    '+s;
   if (_ctim) clearInterval(_ctim);
   _ctim =  setInterval(doneCaption,4800);
}

//--------------------------------------------------------------

function showThis(who) {
   var s = '';
   s += '<img src='+_pre+who+_suf+'>';
   var e = document.getElementById('PICT');
   e.innerHTML = s;

   // if (upd) {
   if (_flip || !_lock) if (who!=_cur) {
      if (_old!='') {
         document.getElementById(_old).value = ""; // not LOCK or PREV
      }
      _old = _cur;
   }
   _cur =  who;
   document.getElementById(_cur).focus();
   document.getElementById(_cur).checked = 1; // current selection
   if (_old) {
      document.getElementById('B2').style.opacity = _old==_cur?'.2':'1';
      document.getElementById(_old).value = _lock ? "LOCK" : "PREV";
   }
   document.getElementById("LOCK").checked = _lock;
   doCaption();
}

//--------------------------------------------------------------

function doFlip() {
   // document.getElementById('LOCK').checked = 0;
   if (_timr) timerOff();
   _flip = 1;;
   showThis(_old);
   _flip = 0;

}

//--------------------------------------------------------------

function timerOff() {
   // alert('Timer off');
   document.getElementById('AUTO').checked = 0;
   clearInterval(_timr);
   _timr = 0;
}

//-------------------------------------------------------------

function doDis() {
   for (i=0;i<_N;i++) if (_id[i]) {
      document.getElementById(_id[i]).disabled = _hlp;
   }
}

//--------------------------------------------------------------

function doHelp() {
   _hlp = ! _hlp;
   var s = _hlp ? 'inline-block' : 'none';
   document.getElementById('HELP').style.display = s;
// alert('doHelp: '+_cur);
   showThis(_cur);
}

//--------------------------------------------------------------

function doLft() {
   if (_timr) timerOff();
   var i = _id.indexOf(_cur);
   do {
      if (!i) i = _N;
      i--;
      if (_id[i]!='') {
         showThis(_id[i]);
         return;
      }
   } while (true);
}

//--------------------------------------------------------------

function doRgt() {
   if (_timr) timerOff();
   var i = _id.indexOf(_cur);
   do {
      i++;
      if (i==_N) i = 0;
      if (_id[i]!='') {
         showThis(_id[i]);
         return;
      }
   } while (true);
}

//--------------------------------------------------------------

function nextRandom() {
   do {
      var i = Math.floor(Math.random()*_N);
      if (_id[i]!='' && _id[i]!=_cur) {
         showThis(_id[i]);
         return;
      }
   } while (true);
}

//--------------------------------------------------------------

function nextSequen() {
   var i = _id.indexOf(_cur);
   do {
      i++;
      if (i==_N) i = 0;
      if (_id[i]!='') {
         showThis(_id[i]);
         return;
      }
   } while (true);
}

//--------------------------------------------------------------

function preLoad() {
   for (i=0;i<_N;i++) if (_id[i]) {
      var s = '<link rel="preload" as="image" href="'+_pre+_id[i]+_suf+'">';
      document.write(s);
   }
}

//--------------------------------------------------------------

function drawMenu() {
   if (_done==0) {
      _ini = getArg('id');
   }
   var buf = '<table id=MAIN><tr>'+
             '<td id=TPIC>'+
             '<div id=PICT onclick="doInterface()"> </div>'+
             '<div id=HELP> </div>'+
             '<div id=LOGO> </div>'+
             '<div id=CAPT> </div>'+
             '<div id=HINT> </div>'+
             '<td id=PANE><table height=100% width=100%>'+
             '<tr height=8%><td id=TOP><tr><td id=MID align=CENTER>'+
             '<tr height=11%><td id=BOT>'+
             '</table></table>';
   document.getElementById('BODY').innerHTML = buf;
/*
   var s = _hide ? '' : 'ALL';
   document.getElementById('HELP').setAttribute('class',s);
   document.getElementById('LOGO').setAttribute('class',s);
   document.getElementById('HINT').setAttribute('class',s);
   document.getElementById('CAPT').setAttribute('class',s);
*/
   buf = '';
   buf += '<div id=LIM>';
   buf += '<table id=LIST><tr>';
   buf += '<td id="M1">';
   buf += '</table>';
   buf += '</div>';
   document.getElementById('MID').innerHTML = buf;
   document.getElementById('TOP').innerHTML = _tit;
   document.title =  "Flipper: "+_tit;
   if (_fsiz!=0) {
      document.getElementById('LIST').style.fontSize = _fsiz+'pt';
      }
   buf = '';
   var ww = "M1";
   for (i=0;i<_N;i++) {
      var s = "";
      var idi = getId(i);
      if (idi) {
         var t = "";
         if (!_ini) {
            _ini = idi;;
            t = " checked";
         }
         s = '<br><input type=RADIO id='+idi+t+
             ' name=x onclick="showThis(this.id);">'+
             ' <label for='+idi+'>'+getLabel(i)+'</label>';
      }
      else {
         s = '<p class=GRP>'+getLabel(i)  +'</p>';
      }
      buf += s;
   }
   if (buf) document.getElementById(ww).innerHTML = buf;
   var ee = document.getElementById(_ini);
   if (ee) ee.focus();
   buf = '<table class=FULL>'+
         '<tr><td id=T1> <td id=T2> <td id=T3>'+
         '<tr><td id=B1> <td id=B2> <td id=B3></table>';
   document.getElementById('BOT').innerHTML = buf;
   buf = '<span class="GRN BUT"><input type="checkbox" id=LOCK onclick="doLock()"> Lock </span>';
   document.getElementById('T1').innerHTML = buf;
   buf = '<span class="GRN BUT"><input type="checkbox" id=RAND onclick="doRand()"> Rand </span>';
   document.getElementById('T2').innerHTML = buf;
   buf = '<span class="GRN BUT"><input type="checkbox" id=AUTO onclick="doAuto()"> Auto </span>';
   document.getElementById('T3').innerHTML = buf;
   buf = '<span class=BUT ID=B2A onclick="doFlip()" value=""> FLIP </span>';
   document.getElementById('B2').innerHTML = buf;

   buf = '<span class="BUT I_BARLF" onclick="doLft()">  </span>';
   document.getElementById('B1').innerHTML = buf;
   buf = '<span class="BUT I_BARRG" onclick="doRgt()">  </span>';
   document.getElementById('B3').innerHTML = buf;
   if (_hide) {
      document.getElementById('PANE' ).style.display = 'none';
      //document.getElementById('PICT').style.width = '100vw';
   }
   else {
      document.getElementById('PANE' ).style.display = 'table-cell';
      //document.getElementById('PICT').style.width = '85vw';
   }
   _cur = _ini;
   if (!_old) _old = _ini;
   showThis(_ini);
   makeHelp();
   document.getElementById('HELP').style.display = 'none';
   //document.getElementById('CAPT').style.display = 'none';
   if (_logo) doLogo();
   _logo = 0;
}

//--------------------------------------------------------------

function prepShow() {
   if (_v1) {
      _N = _oo.length;
      _id.length = _N;
      for (i=0;i<_N;i++) _id[i] = _oo[i][0];
   }
   else {
      _N = _id.length;
   }
   if (_preload) preLoad();
}

//--------------------------------------------------------------

function startTimer() {
   if (_ran) _timr =  setInterval(nextRandom,_dt);
   else      _timr =  setInterval(nextSequen,_dt);
   document.getElementById('AUTO').checked = true;
}

//--------------------------------------------------------------

function doRand() {
   _ran = !_ran;
   // showThis(_cur);
   if (_timr) {
      clearInterval(_timr);
      startTimer();
   }
   document.getElementById(_cur).focus();
   document.getElementById('RAND').checked = _ran;
}

//--------------------------------------------------------------

function doAuto() {
   if (_timr) timerOff();
   else  startTimer();
   document.getElementById('AUTO').checked = _timr;
}

//--------------------------------------------------------------

function doInterface() {
   var o_timr = _timr;
   _ini = _cur;
   if (_timr) timerOff();
   _hide = !_hide;
   var e = document.getElementById("MAIN");
   e.parentNode.removeChild(e);
   _done = 1;
   drawMenu();
   doCaption();
   if (o_timr) startTimer();
}

//--------------------------------------------------------------

function setDelay(d) {
   _idt += d;
   if (_idt<0) _idt = 0;
   if (_idt>9) _idt = 9;
   _dt =1000*Math.pow(2.,_idt/2.);
   if (_timr) {
      clearInterval(_timr);
      startTimer();
   }
}

//--------------------------------------------------------------

function doJump(i) {

   clearInterval(_ktim);
   _ktim = 0;
   if (i<_oi||i>_oi+_N) return;
   i -= _oi;
   var s = getId(i);
   if (s && s!='') showThis(s);
}

//--------------------------------------------------------------


function doneDigit() {

   doJump(_kbuf);
}

//--------------------------------------------------------------

function doDigit(k) {

   if (_ktim==0) {
      _kbuf = k;
      if (_N>9) {
         _ktim = setInterval(doneDigit,_kbd_dt);
      }
      else {
         doJump(_kbuf);
      }
      return;
   }
   _kbuf = _kbuf+k;
   doJump(_kbuf);
}

//----------------------------------------------------------------

function doKey( event ) {

   var k = event.key;
   // doneLogo();
   if (_itim) {
      event.preventDefault(); // this works!
      return;
   }
   if (_hlp) {
      event.preventDefault(); // this works!
      doHelp();
      return;
   }

   switch (k) {
      case '1': case '2': case '3': case '4': case '5':
      case '6': case '7': case '8': case '9': case '0':
         if (_timr) timerOff();
        doDigit(k);
        break;
      case '=': case '+':
         setDelay(1);
         break;
      case '-': case '_':
         setDelay(-1);
         break;
      case 'A':
      case 'a':
         doAuto();
         break;
      case 'C':
      case 'c':
         toggleCaption();
         break;
      case 'R':
      case 'r':
         doRand();
         return; // yes !!
      case 'F':
      case 'f':
         doFlip();
         break;
      case 'L':
      case 'l':
         doLock(); // !!!
         break;
      case 'H':
      case 'h':
      case 'F1':
         if (_timr) timerOff();
         doHelp();
         break;
      case 'U':
      case 'u':
         doInterface();
         break;
      case 'Right':
      case 'ArrowRight':
      case 'ArrowDown':
      case '.':
         if (_timr) timerOff();
         doRgt();
         break;
      case 'Left':
      case 'ArrowLeft':
      case 'ArrowUp':
      case ',':
         if (_timr) timerOff();
         doLft();
         break;
       case 'Backspace':
         window.history.back();
         break;
      case 'F11':
         return;
      default:
         break;
   }
   event.preventDefault(); // this works!
}

//--------------------------------------------------------------

function makeHelp() {
   var s = '<span class=HEAD>The Flipper</span><hr>'+
      '<ul class=HLP>'+
      '<li><span class=RED>RED</span> &mdash; the currently displayed image'+
      '<li><span class=YEL>YELLOW</span> &mdash; the flipping partner of <span class=RED>RED</span>, by default the previous image shown'+
      '<li><span class="I_BARLF KEY"> </span> &nbsp; <span class="I_BARRG KEY"> </span>&nbsp;or&nbsp;'+
          '<span class="I_BARUP KEY"> </span> &nbsp; <span class="I_BARDN KEY"> </span>&nbsp;'+
          'or&nbsp; <span class="HBUT I_BARLF"></span> &nbsp; <span class="HBUT I_BARRG"></span> &mdash; move to previous or next image'+
      '<li><span class=KEY>1</span> &nbsp;...&nbsp;<span class=KEY>9</span>&nbsp;<span clas                                s=KEY>9</span> &mdash; move to that image index'+
      '<li><span class=KEY>U</span> &nbsp; show or hide the user interface'+
      '<li><span class=KEY>C</span> &nbsp; toggle image captions'+
      '<li><span class=KEY>L</span> &nbsp;or&nbsp; <span class=HBUT>Lock</span>&nbsp; lock/unlock the <span class=RED>RED</span> as new <span class=YEL>YELLOW</span> until flipped'+
      '<li><span class=KEY>F</span> &nbsp;or&nbsp; <span class=HBUT>FLIP</span>&nbsp; swap <span class=YEL>YELLOW</span> with <span class=RED>RED</span> (displaying the latter)'+
      '<li><span class=KEY>A</span> &nbsp;or&nbsp; <span class=HBUT>Auto</span>&nbsp; start a slide show'+
      '<li><span class=KEY>+</span> &nbsp; <span class=KEY>-</span>&nbsp; increase/decrease the show rate between 1 and 22 seconds'+
      '<li><span class=KEY>R</span> &nbsp;or&nbsp; <span class=HBUT>Rand</span>&nbsp; random show order on/off'+
      '<li><span class=KEY>H</span> &nbsp;or&nbsp; <span class=KEY>F1</span> &nbsp;call this help'+
      '</ul><hr>'+
      '<table width=96% CLASS=CONT><tr>'+
      '<td class=LFT>Flipper v'+_ver+' &copy;2018-2020 J,A.Wrotniak'+
      '<br> <a href="http://www.wrotniak.net/photo/bytes/flip-swap.html" class=WHI>www.wrotniak.net</a>'+
      '<td class=RGT>Press any key...'+
      '</table>';
   var e = document.getElementById('HELP');
   e.innerHTML = s;
}

//--------------------------------------------------------------

if (_hide!=0) _hide  = 1;
prepShow();
window.onpageshow = drawMenu;
window.addEventListener("keydown", doKey);

// END OF FILE
